// Author: Antonio Navarro
// URL: http://www.thingiverse.com/AntonioNav/
//
// Licencia: CC BY-SA 3.0
//  http://creativecommons.org/licenses/by-sa/3.0/
//
//***********************************************************//
// Config
sav_long=100;
sav_width=65;
sav_height=1.6;

thickness=2.4;
gap=1;

long=sav_long+gap*2+thickness*2;
width=sav_width+gap*2+thickness*2;
box_height=50;

rbolt=2;
hnuts=2.3;


//***********************************************************//

use <Includes/nuts_and_bolts.scad>
use <Includes/roundCornersCube.scad>
use <Includes/cono_soporte.scad>

$fn=50;

//***********************************************************//
//***** Use 'to_print_part1' and 'to_print_part2' ***********//
//***** to generate stl files.                    ***********//

//to_show();
//to_print();
to_print_part1(); 
//to_print_part2(); 

module to_show(){
	color("orange"){
		marco();
		escuadra_izq();
	}
	color("gray"){
		translate([-3,59,57.5])
			rotate([90,180,-90]){
				box();
				translate([0,0,box_height-thickness])
					rotate([0,180,0])
						tapa();
			}
	}
	color("green"){
		translate([-(3+6+5),59,57.5])
			rotate([90,180,-90]){
				sav_mki();
			}
	}
}

module to_print(){
	to_print_part1();
	translate([0,-width-10,0])
		to_print_part2();	
}

module to_print_part1(){
	box();
}

module to_print_part2(){
	tapa();
}

module ducts(){

	stp=7.1;

	intersection(){
		difference(){
			cylinder(r=19, h=20, center=true);
			cylinder(r=7, h=30, center=true);
		}

		for(i=[0:5]){
			translate([0,-17.8+stp*i,0])
				cube([40,5,40],center=true);
		}
	}
}

module tapa(){

	lx=long-thickness*2;
	ly=width-thickness*2;

	difference(){
		union(){
			translate([0,0,-thickness/2])
				roundCornersCube(lx,ly,thickness,3.8);
			translate([lx/2-thickness/2,0,thickness/2-0.3])
				difference(){
					union(){
						cube([thickness*3,ly-25,thickness],center=true);
						translate([0,0,-thickness+0.3])
							soporte(thickness*3,ly-25,thickness, 2);
					}
					cube([12,20,8],center=true);
				}
		}
//		translate([-lx/2+5,ly/2-5,0])
//			cylinder(r=rbolt, h=20, center=true);
//		translate([-lx/2+5,-ly/2+5,0])
//			cylinder(r=rbolt, h=20, center=true);
		translate([0,ly/2-23,0])
			fan();
		letras();
	}
}

module fan(){
	fan_holes();
	ducts();
}

module fan_holes(){
	translate([16,16,0])
		cylinder(r=rbolt, h=30, center=true);
	translate([-16,16,0])
		cylinder(r=rbolt, h=30, center=true);
	translate([16,-16,0])
		cylinder(r=rbolt, h=30, center=true);
	translate([-16,-16,0])
		cylinder(r=rbolt, h=30, center=true);

}

module box(){
	
	difference(){
		translate([0,0,box_height/2])
			roundCornersCube(long,width,box_height,3.8);
		translate([0,0,box_height/2])
			roundCornersCube(long-thickness*2,width-thickness*2,box_height*2,3.8);
//		translate([long/2,0,box_height/2])
//			cube([long-thickness*2,width-thickness*2,box_height*2], center=true);
		translate([0,0,thickness+9.4])
			sav_windows();
		translate([-long/2,0,-10/2+(box_height-thickness+gap)])
			difference(){
				cube([10,width-10,10],center=true);
				cube([12,7,12],center=true);
				soporte(11,width-10,12);
			}
	}

	difference(){
		union(){
			translate([-(long-13)/2,(width-13)/2,(thickness+9.4)/2])
				rotate([0,0,90])
					roundCornerCube_2x(13,13,thickness+9.4,3.8);
			translate([(long-22)/2,(width-20)/2,(thickness+hnuts)/2])
				roundCornerCube_2x(22,20,thickness+hnuts, 3.8);
			translate([-(long-20)/2,-(width-22)/2,(thickness+hnuts)/2])
				roundCornerCube_2x(20,22,thickness+hnuts, 3.8);
			translate([(long-25)/2,-(width-22)/2,(thickness+hnuts)/2])
				rotate([0,0,90])
					roundCornerCube_2x(22,25,thickness+hnuts, 3.8);


//			translate([-(long-10)/2,(width-10)/2,(thickness+9.4)/2])
//				cube([10,10,thickness+9.4], center=true);
			translate([(long-12)/2,(width-12)/2,(thickness+9.4)/2])
				roundCornerCube_2x(12,12,thickness+9.4, 3.8);
			translate([-(long-12)/2,-(width-12)/2,(thickness+9.4)/2])
				roundCornerCube_2x(12,12,thickness+9.4, 3.8);
			translate([(long-12)/2,-(width-12)/2,(thickness+9.4)/2])
				rotate([0,0,90])
					roundCornerCube_2x(12,12,thickness+9.4, 3.8);
		}
		tuercas_marco();
		huecos_marco();
		tuercas_sav();
		huecos_sav();
	}

	soporte_tuercas_sav();

	translate([-long/2+4,width/2-thickness*2+gap,box_height-thickness])
		rotate([0,0,180])
			rail();
	translate([-long/2+4,-width/2+thickness*2-gap,box_height-thickness])
		rail();
	translate([long/2-4,width/2-thickness*2+gap,box_height-thickness])
		rotate([0,0,180])
			rail();
	translate([long/2-4,-width/2+thickness*2-gap,box_height-thickness])
		rail();

/*	translate([long/2-thickness,width/2-thickness,-15+(box_height-thickness+gap)])
		rotate([0,0,-135])
			cono_soporte_hueco(0.1,5,15,1.8);
	translate([long/2-thickness,-width/2+thickness,-15+(box_height-thickness+gap)])
		rotate([0,0,135])
			cono_soporte_hueco(0.1,5,15,1.8);
*/
}

module rail(){

	alto=10;
	ancho=3;
	largo=5;
	
	translate([0,0,-alto/2])
	difference(){
		cube([largo, ancho, alto], center=true);
		translate([0,ancho+1,0])
			rotate([-30,0,0])
				cube([largo+1, ancho*3, alto*2], center=true);
	}
}

module tuercas_marco(){

	translate([34.5,-19.5,thickness+0.1])
		nutHole(3);
	translate([-40,-19.5,thickness+0.1])
		nutHole(3);
	translate([37,28.7,thickness+0.1])
		nutHole(3);
}

module huecos_marco(){
	
	translate([34.5,-19.5,0])
		cylinder(r=rbolt, h=30, center=true);
	translate([-40,-19.5,0])
		cylinder(r=rbolt, h=30, center=true);
	translate([37,28.7,0])
		cylinder(r=rbolt, h=30, center=true);
	translate([-46.2,28.7,0])
		cylinder(r=rbolt, h=30, center=true);
}

module tuercas_sav(){

	translate([46.2,-28.5,-0.1])
		nutHole(3);
	translate([-46,-28.5,-0.1])
		nutHole(3);
	translate([46,28.7,-0.1])
		nutHole(3);
	translate([-46.2,28.7,-0.1])
		nutHole(3);
}

module soporte_tuercas_sav(){

	translate([46.2,-28.5,hnuts])
		cylinder(r=4,h=0.5);
	translate([-46,-28.5,hnuts])
		cylinder(r=4,h=0.5);
	translate([46,28.7,hnuts])
		cylinder(r=4,h=0.5);
	translate([-46.2,28.7,hnuts])
		cylinder(r=4,h=0.5);
}

module huecos_sav(){

	translate([46.2,-28.5,0])
		cylinder(r=rbolt, h=30, center=true);
	translate([-46,-28.5,0])
		cylinder(r=rbolt, h=30, center=true);
	translate([46,28.7,0])
		cylinder(r=rbolt, h=30, center=true);
	translate([-46.2,28.7,0])
		cylinder(r=rbolt, h=30, center=true);
}

module marco(){
	translate([-81.3,0,370])
		rotate([0,90,-90])
			linear_extrude(height=3)
				import("./Includes/Marco.dxf");
}

module escuadra_izq(){
	translate([-3,-213,370])
		rotate([0,90,0])
			linear_extrude(height=3)
				import("./Includes/Escuadra_grande_izq.dxf");
}

module sav_windows(){

	//power, hotend & heatbed
	translate([-(10+sav_long)/2,-1,5.5])
		difference(){
			cube([20,38,9],center=true);
			soporte(21,38,10);
		}
	//USB
	translate([-33.6,-sav_width/2,4])
		difference(){
			cube([11,25,5.5],center=true);
		}
	//Memory card
	translate([sav_long/2,-17.3,4]){
		difference(){
			cube([20,16.5,6],center=true);
			soporte(21,16.5,7);
		}
	}
}

module letras(){

	translate([0,-20,2])
	rotate([180,0,0])
	scale([1,1.2,1]){
		translate([-43,-5,1]){
			p3steel(2*thickness,1);

			translate([43,0,0])
				savmki(2*thickness,1);
		}
	}

}

module p3steel(alt=3,gross=0.8){

	difference(){
		linear_extrude(height=alt)
			import("./Includes/P3Steel_2.dxf");
		translate([2.5,2,-1])
			cube([gross,8,alt+2]);
		translate([26,2,-1])
			cube([gross,5,alt+2]);
		translate([32,2,-1])
			cube([gross,5,alt+2]);
	}
}

module savmki(alt=3,gross=0.8){

	difference(){
		linear_extrude(height=alt)
			import("./Includes/SAVMKI_2.dxf");
		translate([9.3,1,-1])
			cube([gross,8,alt+2]);
	}
}

module soporte(ancho=10, largo=100, alto=10, sep=6){
	pilar=1;
	base=0;

	difference(){
		cube([ancho,largo,alto],center=true);
		translate([0,0,base]) 
			cube([ancho+2,largo+2,alto+0.2], center=true);
	}

	for (i=[0:sep:(largo)]){
		if ((i/sep)%2==1){
			translate([0,i-largo/2,0])
			cube([ancho,pilar,alto],center=true);
		}
	}	

}

module fan40mm(){
			import("./Includes/fan_40mm.stl");
}

module sav_mki(){
			import("./Includes/Modelo_SAV_MKI.stl");
}